# Homework

Over the summer break I advise you to do the following.

1. **practice** what we have learned so far
2. **document** your findings, questions, problems

In order to *help* you a bit I made a markdown template you can use to go over all the topics we touched on and I left some space for you to make your own notes.
You can find this file [here](./todo_template.md).
We did not dive too deep into `git` but if possible I highly recommend to push your notes to the [gitea](https://gitea.86thumbs.net).
This way you can share your findings with your fellow students **and** I can keep an eye on your progress.

## Books

* [The Linux command line](https://linuxcommand.org/index.php) is one of *the* best resources to get good at `bash`
	1. the main book can be downloaded in pdf [here](https://sourceforge.net/projects/linuxcommand/files/TLCL/19.01/TLCL-19.01.pdf/download)
	2. a second book can be downloaded [here](https://sourceforge.net/projects/linuxcommand/files/AWTLCL/21.10/AWTLCL-21.10.pdf/download)
* [The Debian system administrator handbook](https://debian-handbook.info/browse/stable/) is a super reference for all things Debian
* [Unix and Linux System Administration Handbook](https://www.amazon.de/-/en/Evi-Nemeth/dp/0134277554/ref=sr_1_1?keywords=linux+administration&qid=1657794033&s=books&sprefix=linux+admi%2Cstripbooks%2C81&sr=1-1) is **not free** but a very complete handbook with a more general overview

## Online challenges

* regex [crossword](https://m.regexcrossword.com/) puzzles can be a fun way to get better at regexes
* the [cmdchallenge](https://cmdchallenge.com/) is a fun way to get better at pipes and basic commands
* you could continue [bandit](https://overthewire.org/wargames/bandit/) for general practice
	* level [27-28](https://overthewire.org/wargames/bandit/bandit28.html) switches the game up and is all about `git`, you'll need to do some deep diving and I recommend the main [documentation](https://git-scm.com/docs/gittutorial) as a starting point

## Extra info

* you could try and set up `vim` with some plugins to make it a proper [IDE](https://en.wikipedia.org/wiki/Integrated_development_environment); my setup can be found [here](https://gitea.86thumbs.net/waldek/linux_course_doc/src/branch/master/modules/qualifying/learning_vim_configuration.md)
* example project by [Abdellah](https://gitea.86thumbs.net/Abdellah/Project_Hypervisor_KVM_Virtualization) as inspiration for your final project
